#!/bin/bash

# 定义一个包含100个常用单词的数组
words=(
    "apple" "banana" "cherry" "date" "fig" "grape" "kiwi" "lemon" "mango" "nectarine"
    "orange" "peach" "quince" "raspberry" "strawberry" "tangerine" "ugli" "vanilla"
    "watermelon" "xigua" "yam" "zucchini" "blueberry" "blackberry" "cranberry" "dragonfruit"
    "elderberry" "feijoa" "gooseberry" "honeydew" "jackfruit" "kumquat" "lime" "mulberry"
    "nectar" "olive" "papaya" "plum" "pineapple" "pomegranate" "rambutan" "starfruit"
    "tamarind" "coconut" "grapefruit" "lychee" "mandarin" "nectar" "apricot" "avocado"
    "bilberry" "boysenberry" "carambola" "clementine" "currant" "damson" "durian" "guava"
    "jabuticaba" "jujube" "kiwifruit" "loquat" "longan" "lychee" "medlar" "mulberry"
    "nashi" "nonda" "peach" "persimmon" "pineberry" "pitaya" "pluot" "pomegranate"
    "pomelo" "pricklypear" "salmonberry" "satsuma" "serviceberry" "soursop" "tangelo"
    "tayberry" "yuzu" "sugarapple" "cherimoya" "jambul" "jocote" "langsat" "mamoncillo"
    "marionberry" "monstera" "mulberry" "nance" "pawpaw" "safou" "sapodilla" "santol"
)

# 从数组中随机选择两个单词，并拼接在一起作为新的 package 名称
generate_random_name() {
    word1=${words[$RANDOM % ${#words[@]}]}
    word2=${words[$RANDOM % ${#words[@]}]}
    echo "${word1}${word2}"
}

while true; do
    # 生成新的 package name
    new_package_name=$(generate_random_name)
    echo "New package name: $new_package_name"

    # 修改 package.json 中的 name 字段
    sed -i "s/\"name\": \".*\"/\"name\": \"$new_package_name\"/" package.json
    echo "Modified package.json"

    # 发布 npm 包
    echo "Publishing npm package..."
    npm publish

    # 等待 2 分钟
    echo "Waiting for 2 minutes..."
    sleep 2m
done
